<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for foraeldremyndighedType StructType
 * @subpackage Structs
 */
class ForaeldremyndighedType extends AbstractStructBase
{
    /**
     * The foraeldremyndighedtype
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $foraeldremyndighedtype;
    /**
     * The foraeldremyndighedStartdato
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\UsikkerhedDatoType
     */
    public $foraeldremyndighedStartdato;
    /**
     * The foraeldremyndighedSletdato
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $foraeldremyndighedSletdato;
    /**
     * The relationPersonnummer
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - maxLength: 10
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $relationPersonnummer;
    /**
     * The relationStartdato
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $relationStartdato;
    /**
     * Constructor method for foraeldremyndighedType
     * @uses ForaeldremyndighedType::setForaeldremyndighedtype()
     * @uses ForaeldremyndighedType::setForaeldremyndighedStartdato()
     * @uses ForaeldremyndighedType::setForaeldremyndighedSletdato()
     * @uses ForaeldremyndighedType::setRelationPersonnummer()
     * @uses ForaeldremyndighedType::setRelationStartdato()
     * @param string $foraeldremyndighedtype
     * @param \StructType\UsikkerhedDatoType $foraeldremyndighedStartdato
     * @param string $foraeldremyndighedSletdato
     * @param string $relationPersonnummer
     * @param string $relationStartdato
     */
    public function __construct($foraeldremyndighedtype = null, \StructType\UsikkerhedDatoType $foraeldremyndighedStartdato = null, $foraeldremyndighedSletdato = null, $relationPersonnummer = null, $relationStartdato = null)
    {
        $this
            ->setForaeldremyndighedtype($foraeldremyndighedtype)
            ->setForaeldremyndighedStartdato($foraeldremyndighedStartdato)
            ->setForaeldremyndighedSletdato($foraeldremyndighedSletdato)
            ->setRelationPersonnummer($relationPersonnummer)
            ->setRelationStartdato($relationStartdato);
    }
    /**
     * Get foraeldremyndighedtype value
     * @return string
     */
    public function getForaeldremyndighedtype()
    {
        return $this->foraeldremyndighedtype;
    }
    /**
     * Set foraeldremyndighedtype value
     * @uses \EnumType\ForaeldremyndighedTypeType::valueIsValid()
     * @uses \EnumType\ForaeldremyndighedTypeType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $foraeldremyndighedtype
     * @return \StructType\ForaeldremyndighedType
     */
    public function setForaeldremyndighedtype($foraeldremyndighedtype = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\ForaeldremyndighedTypeType::valueIsValid($foraeldremyndighedtype)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\ForaeldremyndighedTypeType', is_array($foraeldremyndighedtype) ? implode(', ', $foraeldremyndighedtype) : var_export($foraeldremyndighedtype, true), implode(', ', \EnumType\ForaeldremyndighedTypeType::getValidValues())), __LINE__);
        }
        $this->foraeldremyndighedtype = $foraeldremyndighedtype;
        return $this;
    }
    /**
     * Get foraeldremyndighedStartdato value
     * @return \StructType\UsikkerhedDatoType|null
     */
    public function getForaeldremyndighedStartdato()
    {
        return $this->foraeldremyndighedStartdato;
    }
    /**
     * Set foraeldremyndighedStartdato value
     * @param \StructType\UsikkerhedDatoType $foraeldremyndighedStartdato
     * @return \StructType\ForaeldremyndighedType
     */
    public function setForaeldremyndighedStartdato(\StructType\UsikkerhedDatoType $foraeldremyndighedStartdato = null)
    {
        $this->foraeldremyndighedStartdato = $foraeldremyndighedStartdato;
        return $this;
    }
    /**
     * Get foraeldremyndighedSletdato value
     * @return string|null
     */
    public function getForaeldremyndighedSletdato()
    {
        return $this->foraeldremyndighedSletdato;
    }
    /**
     * Set foraeldremyndighedSletdato value
     * @param string $foraeldremyndighedSletdato
     * @return \StructType\ForaeldremyndighedType
     */
    public function setForaeldremyndighedSletdato($foraeldremyndighedSletdato = null)
    {
        // validation for constraint: string
        if (!is_null($foraeldremyndighedSletdato) && !is_string($foraeldremyndighedSletdato)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($foraeldremyndighedSletdato, true), gettype($foraeldremyndighedSletdato)), __LINE__);
        }
        $this->foraeldremyndighedSletdato = $foraeldremyndighedSletdato;
        return $this;
    }
    /**
     * Get relationPersonnummer value
     * @return string|null
     */
    public function getRelationPersonnummer()
    {
        return $this->relationPersonnummer;
    }
    /**
     * Set relationPersonnummer value
     * @param string $relationPersonnummer
     * @return \StructType\ForaeldremyndighedType
     */
    public function setRelationPersonnummer($relationPersonnummer = null)
    {
        // validation for constraint: string
        if (!is_null($relationPersonnummer) && !is_string($relationPersonnummer)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($relationPersonnummer, true), gettype($relationPersonnummer)), __LINE__);
        }
        // validation for constraint: maxLength(10)
        if (!is_null($relationPersonnummer) && mb_strlen($relationPersonnummer) > 10) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 10', mb_strlen($relationPersonnummer)), __LINE__);
        }
        $this->relationPersonnummer = $relationPersonnummer;
        return $this;
    }
    /**
     * Get relationStartdato value
     * @return string|null
     */
    public function getRelationStartdato()
    {
        return $this->relationStartdato;
    }
    /**
     * Set relationStartdato value
     * @param string $relationStartdato
     * @return \StructType\ForaeldremyndighedType
     */
    public function setRelationStartdato($relationStartdato = null)
    {
        // validation for constraint: string
        if (!is_null($relationStartdato) && !is_string($relationStartdato)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($relationStartdato, true), gettype($relationStartdato)), __LINE__);
        }
        $this->relationStartdato = $relationStartdato;
        return $this;
    }
}
