<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for relationerType StructType
 * @subpackage Structs
 */
class RelationerType extends AbstractStructBase
{
    /**
     * The aegtefaelle
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\PersonRelationType
     */
    public $aegtefaelle;
    /**
     * The barn
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\BarnType[]
     */
    public $barn;
    /**
     * The mor
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\PersonRelationType
     */
    public $mor;
    /**
     * The far
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\PersonRelationType
     */
    public $far;
    /**
     * The foraeldremyndighed
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ForaeldremyndighedType[]
     */
    public $foraeldremyndighed;
    /**
     * Constructor method for relationerType
     * @uses RelationerType::setAegtefaelle()
     * @uses RelationerType::setBarn()
     * @uses RelationerType::setMor()
     * @uses RelationerType::setFar()
     * @uses RelationerType::setForaeldremyndighed()
     * @param \StructType\PersonRelationType $aegtefaelle
     * @param \StructType\BarnType[] $barn
     * @param \StructType\PersonRelationType $mor
     * @param \StructType\PersonRelationType $far
     * @param \StructType\ForaeldremyndighedType[] $foraeldremyndighed
     */
    public function __construct(\StructType\PersonRelationType $aegtefaelle = null, array $barn = array(), \StructType\PersonRelationType $mor = null, \StructType\PersonRelationType $far = null, array $foraeldremyndighed = array())
    {
        $this
            ->setAegtefaelle($aegtefaelle)
            ->setBarn($barn)
            ->setMor($mor)
            ->setFar($far)
            ->setForaeldremyndighed($foraeldremyndighed);
    }
    /**
     * Get aegtefaelle value
     * @return \StructType\PersonRelationType|null
     */
    public function getAegtefaelle()
    {
        return $this->aegtefaelle;
    }
    /**
     * Set aegtefaelle value
     * @param \StructType\PersonRelationType $aegtefaelle
     * @return \StructType\RelationerType
     */
    public function setAegtefaelle(\StructType\PersonRelationType $aegtefaelle = null)
    {
        $this->aegtefaelle = $aegtefaelle;
        return $this;
    }
    /**
     * Get barn value
     * @return \StructType\BarnType[]|null
     */
    public function getBarn()
    {
        return $this->barn;
    }
    /**
     * This method is responsible for validating the values passed to the setBarn method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBarn method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBarnForArrayConstraintsFromSetBarn(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $relationerTypeBarnItem) {
            // validation for constraint: itemType
            if (!$relationerTypeBarnItem instanceof \StructType\BarnType) {
                $invalidValues[] = is_object($relationerTypeBarnItem) ? get_class($relationerTypeBarnItem) : sprintf('%s(%s)', gettype($relationerTypeBarnItem), var_export($relationerTypeBarnItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The barn property can only contain items of type \StructType\BarnType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set barn value
     * @throws \InvalidArgumentException
     * @param \StructType\BarnType[] $barn
     * @return \StructType\RelationerType
     */
    public function setBarn(array $barn = array())
    {
        // validation for constraint: array
        if ('' !== ($barnArrayErrorMessage = self::validateBarnForArrayConstraintsFromSetBarn($barn))) {
            throw new \InvalidArgumentException($barnArrayErrorMessage, __LINE__);
        }
        $this->barn = $barn;
        return $this;
    }
    /**
     * Add item to barn value
     * @throws \InvalidArgumentException
     * @param \StructType\BarnType $item
     * @return \StructType\RelationerType
     */
    public function addToBarn(\StructType\BarnType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\BarnType) {
            throw new \InvalidArgumentException(sprintf('The barn property can only contain items of type \StructType\BarnType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->barn[] = $item;
        return $this;
    }
    /**
     * Get mor value
     * @return \StructType\PersonRelationType|null
     */
    public function getMor()
    {
        return $this->mor;
    }
    /**
     * Set mor value
     * @param \StructType\PersonRelationType $mor
     * @return \StructType\RelationerType
     */
    public function setMor(\StructType\PersonRelationType $mor = null)
    {
        $this->mor = $mor;
        return $this;
    }
    /**
     * Get far value
     * @return \StructType\PersonRelationType|null
     */
    public function getFar()
    {
        return $this->far;
    }
    /**
     * Set far value
     * @param \StructType\PersonRelationType $far
     * @return \StructType\RelationerType
     */
    public function setFar(\StructType\PersonRelationType $far = null)
    {
        $this->far = $far;
        return $this;
    }
    /**
     * Get foraeldremyndighed value
     * @return \StructType\ForaeldremyndighedType[]|null
     */
    public function getForaeldremyndighed()
    {
        return $this->foraeldremyndighed;
    }
    /**
     * This method is responsible for validating the values passed to the setForaeldremyndighed method
     * This method is willingly generated in order to preserve the one-line inline validation within the setForaeldremyndighed method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateForaeldremyndighedForArrayConstraintsFromSetForaeldremyndighed(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $relationerTypeForaeldremyndighedItem) {
            // validation for constraint: itemType
            if (!$relationerTypeForaeldremyndighedItem instanceof \StructType\ForaeldremyndighedType) {
                $invalidValues[] = is_object($relationerTypeForaeldremyndighedItem) ? get_class($relationerTypeForaeldremyndighedItem) : sprintf('%s(%s)', gettype($relationerTypeForaeldremyndighedItem), var_export($relationerTypeForaeldremyndighedItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The foraeldremyndighed property can only contain items of type \StructType\ForaeldremyndighedType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set foraeldremyndighed value
     * @throws \InvalidArgumentException
     * @param \StructType\ForaeldremyndighedType[] $foraeldremyndighed
     * @return \StructType\RelationerType
     */
    public function setForaeldremyndighed(array $foraeldremyndighed = array())
    {
        // validation for constraint: array
        if ('' !== ($foraeldremyndighedArrayErrorMessage = self::validateForaeldremyndighedForArrayConstraintsFromSetForaeldremyndighed($foraeldremyndighed))) {
            throw new \InvalidArgumentException($foraeldremyndighedArrayErrorMessage, __LINE__);
        }
        $this->foraeldremyndighed = $foraeldremyndighed;
        return $this;
    }
    /**
     * Add item to foraeldremyndighed value
     * @throws \InvalidArgumentException
     * @param \StructType\ForaeldremyndighedType $item
     * @return \StructType\RelationerType
     */
    public function addToForaeldremyndighed(\StructType\ForaeldremyndighedType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ForaeldremyndighedType) {
            throw new \InvalidArgumentException(sprintf('The foraeldremyndighed property can only contain items of type \StructType\ForaeldremyndighedType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->foraeldremyndighed[] = $item;
        return $this;
    }
}
