<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for statusType StructType
 * @subpackage Structs
 */
class StatusType extends AbstractStructBase
{
    /**
     * The status
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $status;
    /**
     * The statusdato
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\UsikkerhedDatoTidType
     */
    public $statusdato;
    /**
     * Constructor method for statusType
     * @uses StatusType::setStatus()
     * @uses StatusType::setStatusdato()
     * @param string $status
     * @param \StructType\UsikkerhedDatoTidType $statusdato
     */
    public function __construct($status = null, \StructType\UsikkerhedDatoTidType $statusdato = null)
    {
        $this
            ->setStatus($status)
            ->setStatusdato($statusdato);
    }
    /**
     * Get status value
     * @return string|null
     */
    public function getStatus()
    {
        return $this->status;
    }
    /**
     * Set status value
     * @uses \EnumType\StatusTypeType::valueIsValid()
     * @uses \EnumType\StatusTypeType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $status
     * @return \StructType\StatusType
     */
    public function setStatus($status = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\StatusTypeType::valueIsValid($status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\StatusTypeType', is_array($status) ? implode(', ', $status) : var_export($status, true), implode(', ', \EnumType\StatusTypeType::getValidValues())), __LINE__);
        }
        $this->status = $status;
        return $this;
    }
    /**
     * Get statusdato value
     * @return \StructType\UsikkerhedDatoTidType|null
     */
    public function getStatusdato()
    {
        return $this->statusdato;
    }
    /**
     * Set statusdato value
     * @param \StructType\UsikkerhedDatoTidType $statusdato
     * @return \StructType\StatusType
     */
    public function setStatusdato(\StructType\UsikkerhedDatoTidType $statusdato = null)
    {
        $this->statusdato = $statusdato;
        return $this;
    }
}
